#include<iostream>

using namespace std;

int row_eval(int array[][5], int row_num);	//static evaluation helper
int col_eval(int array[][5], int col_num);	//static evaluation helper
void pop_board(int array[][5]);		//game board
void eval(int array[][5]);		//static evaluation function
int find_high(int array[][5]);
void play(int array[][5]);
bool check_for_Mwin(int array[][5]);	//check for computer win
bool check_for_Wwin(int array[][5]);	//check for opponent win
void board_status(int array[][5], char board[][5], char init1);
void player_M(int array[][5]);			//computer 
void player_W(int array[][5]);			//opponent
void reset(int array[][5]);			//resets board for static evaluation

int main()
{
	int arr[5][5];
	char chart[5][5];
	char initial;			//player initial
	char answer;
	bool proceed = false;
	pop_board(arr);
	cout<<"**********************************************************************"<<endl;
	cout<<"                   Welcome to the Pathway Game!                       "<<endl;
	cout<<endl<<"This object of this game is to create a path of adjacent initials ";
	cout<<"from "<<endl<<"one end of the board to the other end whether vertical or horizontal."<<endl;
	cout<<"**********************************************************************"<<endl;
	cout<<endl<<"                      Let's Begin!  Good Luck                     "<<endl<<endl;

	cout<<"Please type in your first initial!"<<endl;
	cout<<"Note:  The computer will be M so please choice a different initial."<<endl;

	cin>>initial;
	cout<<endl;
	cout<<endl<<"Would you like to play first?"<<endl;

while(proceed==false)
{
	cout<<"Please enter 'y' for yes or 'n' for no."<<endl;
	cin>>answer;
	cout<<endl<<endl;
	if(answer == 'y' || answer == 'Y')	//human player goes first
	{
		while(check_for_Mwin(arr) == false && check_for_Wwin(arr) == false)
		{
			board_status(arr, chart, initial);
			player_W(arr);
			cout<<endl;
			cout<<"YOUR MOVE IS AS FOLLOWS:"<<endl<<endl;
			board_status(arr, chart, initial);
			cout<<endl;
			

			if(check_for_Wwin(arr) == true)
			{
				cout<<endl;
				cout<<"Congratulations!!!  You have defeated the computer...humans prevail!!!"<<endl;
				return 0;
			}

			player_M(arr);
			board_status(arr, chart, initial);

			if(check_for_Mwin(arr) == true)
			{
				cout<<endl;
				cout<<"The computer has defeated you! Machines will take over the earth!"<<endl;
				return 0;
			}

			system("pause");
			system("cls");

			reset(arr);		
		}
		proceed = true;
	}

	else if(answer == 'n' || answer == 'N')		//computer goes first
	{

		while(check_for_Mwin(arr) == false && check_for_Wwin(arr) == false)
		{
			player_M(arr);
			board_status(arr, chart, initial);

			if(check_for_Mwin(arr) == true)
			{
				cout<<endl;
				cout<<"The computer has defeated you! Machines will take over the earth!"<<endl;
				return 0;
			}

			player_W(arr);
			cout<<endl;
			cout<<"YOUR MOVE IS AS FOLLOWS:"<<endl<<endl;
			board_status(arr, chart, initial);
			cout<<endl;
		
			system("pause");
			system("cls");

			if(check_for_Wwin(arr) == true)
			{
				cout<<endl;
				cout<<"Congratulations!!!  You have defeated the computer...humans rock!!!"<<endl;
				return 0;
			}

			reset(arr);		
		}
		proceed = true;
	}

		else		//for error checking
		{
			cout<<"That was not a valid entry!  Please try again."<<endl;
			proceed = false;
		}

}
	return(0);	//just here so that i won't have any warnings		
}

int col_eval(int array[][5], int col_num, int fof)	//static evaluation helper
{
	int col_count = 0;
	
	for(int i=0; i<5; i++)
	{
		if(array[i][col_num] == fof)		//count the number of M's in each row
			col_count++;
	}

	return col_count;
}

int row_eval(int array[][5], int row_num, int fof)	//static evaluation helper
{
	int row_count = 0;
	
	for(int i=0; i<5; i++)
	{
		if(array[row_num][i] == fof)		//count the number of M's in each column
			row_count++;
	}

	return row_count;
}

void pop_board(int array[][5])		//initialize game board
{
	for(int j=0; j<5; j++)
	{
		for(int k=0; k<5; k++)
		{
			if(k%2==0 && j%2==0)
				array[j][k] = 0;
			else if(j%2==0 && k%2!=0)
				array[j][k] = -1;
			else if(j%2!=0 && k%2==0)
				array[j][k] = 1;
			else
				array[j][k] = 0;
		}
	}
}

void board_status(int array[][5], char board[][5], char init1)	//game board
{
	if(init1>64 && init1<91)		//makes initial capital letter
		init1=init1;
	else
		init1-=32;

	cout<<"Current Board Status:"<<endl;
	int count=0;
	cout<<"  ";
	while(count < 5)
	{
		cout<<count<<" ";
		count++;
	}
	cout<<endl<<endl;
	count=0;

	for(int m=0; m<5; m++)		//show board
	{
		for(int n=0; n<5; n++)
		{
			if(array[m][n] == 1)
				board[m][n] = 'M';
			else if(array[m][n] == -1)
				board[m][n] = init1;
			else
				board[m][n] = ' ';
		}
	}

	for(int w=0; w<5; w++)
			for(int l=0; l<5; l++)
			{
				if(l==0)
				{
					cout<<count<<" ";
					count++;
				}
				cout<<board[w][l]<<" ";
				if(l==4)
					cout<<endl;
			}
		
}

void eval(int array[][5])			//static evaluation function
{
	int row_buddies=0;
	int col_buddies=0;

	int row_enemies=0;
	int col_enemies=0;
	int holder;					//makes values unique

	for(int row=0; row<5; row++)
		for(int col=0; col<5; col++)
		{
			if(array[row][col]!=0)
				;
			else 
			{
				if(row==2 && col==2)
					array[row][col] += 200;
				holder = 2*(row+1) + col;
			
				row_buddies += row_eval(array, row, 1);
				col_buddies += col_eval(array, col, 1);
				row_enemies += row_eval(array, row, -1);
				col_enemies += col_eval(array, col, -1);

				switch(row_enemies)
				{
				case 0:
					break;
				case 1:
					array[row][col] += 50;
					break;
				case 2:
					array[row][col] += 100;
					break;
				case 3:
					array[row][col] += 250;
					break;
				case 4:
					array[row][col] += 500;
					break;
				}

				switch(col_enemies)
				{
				case 0:
					break;
				case 1:
					array[row][col] += 50;
					break;
				case 2:
					array[row][col] += 100;
					break;
				case 3:
					array[row][col] += 250;
					break;
				case 4:
					array[row][col] += 500;
					break;
				}

				switch(col_buddies)
				{
				case 0:
					break;
				case 1:
					{
					array[row][col] += holder;
					array[row][col] += 100;
					}
					break;
				case 2:
					{
					array[row][col] += holder;
					array[row][col] += 500;
					}
					break;
				case 3:
					{
					array[row][col] += holder;
					array[row][col] += 800;
					}
					break;
				case 4:
					{		
					array[row][col] += holder;
					array[row][col] += 1000;
					}
					break;
				}

				switch(row_buddies)
				{
				case 0:
					break;
				case 1:
					array[row][col] += 100;
					array[row][col] += holder;
					break;
				case 2:
					array[row][col] += 500;
					array[row][col] += holder;
					break;
				case 3:
					array[row][col] += 800;
					array[row][col] += holder;
					break;
				case 4:
					array[row][col] += 1000;
					array[row][col] += holder;
					break;
				}
				
				row_buddies = 0;
				col_buddies = 0;
				row_enemies = 0;
				col_enemies = 0;

			}	

		}
	
}

int find_high(int array[][5])		//finds location for computer to play at
{
	int high;
	high = 0;

	for(int row=0; row<5; row++)
		for(int col=0; col<5; col++)
			if(array[row][col] > high)
				high = array[row][col];
			
	return high;
}

void play(int array[][5])		//the computers move
{
	int took_turn=0;
	for(int row=0; row<5; row++)
		for(int col=0; col<5; col++)
			if(array[row][col] == find_high(array) && took_turn==0)
			{
				array[row][col] = 1;

				cout<<"The computer has decided to play a M at the following location:"<<endl;
				cout<<"Row: "<<row<<" Col: "<<col<<endl<<endl;
				took_turn++;
			}
}

bool check_for_Mwin(int array[][5])		//check for computer win
{
	bool gametime = false;
	
	//column 0 victory for M  
	if(array[0][0] == 1 && array[2][0] == 1 && array[4][0] == 1)
		gametime = true;
	if(array[0][0] == 1 && array[1][1] == 1 && array[2][2] == 1 && array[4][2] == 1)
		gametime = true;
	if(array[0][0] == 1 && array[2][0] == 1 && array[3][1] == 1 && array[4][2] == 1)
		gametime = true;
	if(array[0][0] && array[1][1] && array[2][2] && array[3][1] && array[4][0] == 1)
		gametime = true;
	
	//column 2 victory for M  
	if(array[0][2] == 1 && array[2][2] == 1 && array[4][2] == 1)
		gametime = true;
	if(array[0][2] == 1 && array[1][1] == 1 && array[0][2] == 1 && array[2][4] == 1)
		gametime = true;
	if(array[0][2] == 1 && array[2][2] == 1 && array[3][1] == 1 && array[4][0] == 1)
		gametime = true;
	if(array[0][2] == 1 && array[1][3] == 1 && array[2][4] == 1 && array[4][4] == 1)
		gametime = true;
	if(array[0][2] == 1 && array[2][2] == 1 && array[3][3] == 1 && array[4][4] == 1)
		gametime = true;

	//column 4 victory for M  
	if(array[0][4] == 1 && array[2][4] == 1 && array[4][4] == 1)
		gametime = true;
	if(array[0][4] == 1 && array[1][3] == 1 && array[2][2] == 1 && array[4][2] == 1)
		gametime = true;
	if(array[0][4] == 1 && array[2][4] == 1 && array[3][3] == 1 && array[4][2] == 1)
		gametime = true;
	if(array[0][4] == 1 && array[1][3] == 1 && array[2][2] == 1 && array[3][3] == 1 && array[4][4] == 1)
		gametime = true;

	//row 1 or 3 victory for M  
	if(array[1][0] == 1 && array[1][1] == 1 && array[1][3] == 1)
		gametime = true;
	if(array[3][0] == 1 && array[3][1] == 1 && array[3][3] == 1)
		gametime = true;
	if(array[1][1] == 1 && array[2][2] == 1 && array[3][3] == 1)
		gametime = true;
	if(array[1][3] == 1 && array[2][2] == 1 && array[3][1] == 1)
		gametime = true;

	return gametime;
}

bool check_for_Wwin(int array[][5])		//check for human player win
{
	bool gametime = false;

	//row 0 victory for W
	if(array[0][0] == -1 && array[0][2] == -1 && array[0][4] == -1)
		gametime = true;
	if(array[0][0] == -1 && array[1][1] == -1 && array[2][2] == -1 && array[2][4] == -1)
		gametime = true;
	if(array[0][0] == -1 && array[0][2] == -1 && array[1][3] == -1 && array[2][4] == -1)
		gametime = true;

	//row 2 victory for W
	if(array[2][0] == -1 && array[2][2] == -1 && array[2][4] == -1)
		gametime = true;
	if(array[2][0] == -1 && array[1][1] == -1 && array[0][2] == -1 && array[0][4] == -1)
		gametime = true;
	if(array[2][0] == -1 && array[3][1] == -1 && array[4][2] == -1 && array[4][4] == -1)
		gametime = true;
	if(array[2][0] == -1 && array[2][2] == -1 && array[3][3] == -1 && array[4][4] == -1)
		gametime = true;
	if(array[2][0] == -1 && array[2][2] == -1 && array[1][3] == -1 && array[0][4] == -1)
		gametime = true;

	//row 4 victory for W
	if(array[4][0] == -1 && array[4][2] == -1 && array[4][4] == -1)
		gametime = true;
	if(array[4][0] == -1 && array[3][1] == -1 && array[2][2] == -1 && array[2][4] == -1)
		gametime = true;
	if(array[4][0] == -1 && array[4][2] == -1 && array[3][3] == -1 && array[2][4] == -1)
		gametime = true;

	//col 1 or 4 victory for W
	if(array[0][1] == -1 && array[1][1] == -1 && array[3][1] == -1)
		gametime = true;
	if(array[0][3] == -1 && array[1][3] == -1 && array[3][3] == -1)
		gametime = true;
	if(array[1][1] == -1 && array[2][2] == -1 && array[3][3] == -1)
		gametime = true;
	if(array[1][3] == -1 && array[2][2] == -1 && array[3][1] == -1)
		gametime = true;
	
	return gametime;
}

void player_M(int array[][5])	//computer player
{
	eval(array);
	find_high(array);
	play(array);
}

void player_W(int array[][5])	//human player
{
	int row_choice;
	int col_choice;
	bool row_proceed = false;
	bool col_proceed = false;
	int count = 1;
	cout<<endl;
	cout<<"Your move choices are in the following format below ";
	cout<<"(row,col)"<<endl<<"please choose a move from the list!"<<endl;
	cout<<endl;

	for(int j=0; j<5; j++)		//display available moves
		for(int k=0; k<5; k++)
		{
			if(array[j][k]!=1 && array[j][k]!=-1)
			{	
				cout<<"("<<j<<", "<<k<<")"<<"     ";
				count++;
			}
			if(count==4)
			{
				cout<<endl;
				count = 1;
			}
		}
		cout<<endl;

		while(row_proceed==false || col_proceed==false)
		{
			cout<<"What is your row choice?"<<endl;
			cin>>row_choice;
			if(row_choice >= 0 && row_choice < 5)
				row_proceed=true;

			cout<<"What is your column choice?"<<endl;
			cin>>col_choice;
			if(col_choice >= 0 && col_choice < 5)
				col_proceed=true;

			if(array[row_choice][col_choice]==1 || array[row_choice][col_choice]==-1)
				col_proceed=false;
					
			if(col_proceed==false || row_proceed==false)
			{
				cout<<"Please choose a location from the list!  Try again please."<<endl;
				system("pause");
			}

			else
				array[row_choice][col_choice] = -1;

		}
}

void reset(int array[][5])		//if array location != 1 or -1 make it 0
{
	for(int start=0; start<5; start++)
			for(int end=0; end<5; end++)
			{
				if(array[start][end]== 1 || array[start][end]== -1)
					;
				else
					array[start][end]=0;
			}
}